using SoftwareInstallationContracts.BindingModels;
using SoftwareInstallationContracts.ViewModels;
using SoftwareInstallationDataModels;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SoftwareInstallationDatabaseImplement.Models
{
    public class Client : IClientModel
    {
        [Required]
        public string ClientFIO { get; private set; } = string.Empty;

        [Required]
        public string Email { get; private set; } = string.Empty;

        [Required]
        public string Password { get; private set; } = string.Empty;

        public int Id { get; private set; }

        [ForeignKey("ClientId")]
        public virtual List<Order> Orders { get; set; } = new();

		[ForeignKey("ClientId")]
		public virtual List<MessageInfo> Messages { get; set; } = new();

		public static Client? Create(ClientBindingModel model)
        {
            if (model == null)
            {
                return null;
            }
            return new()
            {
                Id = model.Id,
                ClientFIO = model.ClientFIO,
                Email = model.Email,
                Password = model.Password
            };
        }

        public void Update(ClientBindingModel model)
        {
            if (model == null)
            {
                return;
            }
            ClientFIO = model.ClientFIO;
            Email = model.Email;
            Password = model.Password;
        }

        public ClientViewModel GetViewModel => new()
        {
            Id = Id,
            ClientFIO = ClientFIO,
            Email = Email,
            Password = Password,
        };
    }
}
